import { ElementType, useEffect, useRef } from 'react';

export const WithHocTitle = (
  Component: ElementType,
  title?: string
) => {
  return function WithHocTitleComponent({ ...props }: {
    [key: string]: any;
  }) {
    const { current } = useRef(document.title);

    useEffect(() => {
      if (title) {
        document.title = title;
      } else {
        document.title = current;
      }
    }, []);

    return (
      <Component
        {...props}
      />
    );
  };
};
